## ros-melodic-canopen-chain-node 0.8.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(canopen_chain_node)

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
  set(CMAKE_CXX_STANDARD 14)
endif()

find_package(catkin REQUIRED
  COMPONENTS
    canopen_master
    diagnostic_updater
    message_generation
    pluginlib
    rosconsole_bridge
    roscpp
    roslib
    socketcan_interface
    std_msgs
    std_srvs
)

find_package(Boost REQUIRED
  COMPONENTS
    filesystem
)

add_service_files(DIRECTORY srv
                  FILES
                  GetObject.srv
                  SetObject.srv)

generate_messages(DEPENDENCIES)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    canopen_ros_chain
  CATKIN_DEPENDS
    canopen_master
    diagnostic_updater
    message_runtime
    pluginlib
    rosconsole_bridge
    roscpp
    socketcan_interface
    std_srvs
  DEPENDS
    Boost
)

include_directories(
  include
  ${Boost_INCLUDE_DIRS}
  ${catkin_INCLUDE_DIRS}
)

# canopen_ros_chain
add_library(canopen_ros_chain
  src/ros_chain.cpp
  src/rosconsole_bridge.cpp
)
target_link_libraries(canopen_ros_chain
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
)
add_dependencies(canopen_ros_chain
  ${catkin_EXPORTED_TARGETS}
  ${${PROJECT_NAME}_EXPORTED_TARGETS}
)

# canopen_chain_node
add_executable(${PROJECT_NAME}
  src/chain_node.cpp
)
target_link_libraries(${PROJECT_NAME}
  canopen_ros_chain
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
)

# canopen_sync_node
add_executable(canopen_sync_node
  src/rosconsole_bridge.cpp
  src/sync_node.cpp
)
target_link_libraries(canopen_sync_node
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
)

install(
  TARGETS
    ${PROJECT_NAME}
    canopen_ros_chain
    canopen_sync_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(
  DIRECTORY
    include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

install(
  DIRECTORY
    launch
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-melodic-canopen-chain-node (0.8.5-1bionic) bionic; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 21 Sep 2020 22:00:00 -0000

ros-melodic-canopen-chain-node (0.8.4-1bionic) bionic; urgency=high

  * pass settings from ROS node to SocketCANInterface
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 21 Aug 2020 22:00:00 -0000

ros-melodic-canopen-chain-node (0.8.3-1bionic) bionic; urgency=high

  * Bump CMake version to avoid CMP0048 warning
    Signed-off-by: ahcorde <mailto:ahcorde@gmail.com>
  * Contributors: ahcorde

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Wed, 06 May 2020 22:00:00 -0000

ros-melodic-canopen-chain-node (0.8.2-1bionic) bionic; urgency=high

  * rename to logWarning to fix build on Debian stretch
  * log the result of all services in RosChain
  * enable rosconsole_bridge bindings
  * switch to new logging macros
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 03 Nov 2019 23:00:00 -0000

ros-melodic-canopen-chain-node (0.8.1-1bionic) bionic; urgency=high

  * Set C++ standard to c++14
  * implemented create*ListenerM helpers
  * Replacing FastDelegate with std::function and std::bind.
  * Contributors: Alexander Gutenkunst, Harsh Deshpande, Joshua Whitley, Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sat, 13 Jul 2019 22:00:00 -0000

ros-melodic-canopen-chain-node (0.8.0-1bionic) bionic; urgency=high

  * migrated to std::function and std::bind
  * make sync_node return proper error codes
  * refactored PublishFunc
  * migrated to std::atomic
  * migrated to std pointers
  * removed deprecated types
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 10 Jul 2018 22:00:00 -0000

ros-melodic-canopen-chain-node (0.7.8-1bionic) bionic; urgency=high

  * Revert "pull make_shared into namespaces"
    This reverts commit 9b2cd05df76d223647ca81917d289ca6330cdee6.
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 03 May 2018 22:00:00 -0000

ros-melodic-canopen-chain-node (0.7.7-1bionic) bionic; urgency=high

  * added types for all function objects
  * pull make_shared into namespaces
  * added types for all shared_ptrs
  * migrate to new classloader headers
  * address catkin_lint errors/warnings
  * removed IPC/SHM based sync masters
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 03 May 2018 22:00:00 -0000

ros-melodic-canopen-chain-node (0.7.6-1bionic) bionic; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 29 Aug 2017 22:00:00 -0000

ros-melodic-canopen-chain-node (0.7.5-1bionic) bionic; urgency=high

  * added reset_errors_before_recover option
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 28 May 2017 22:00:00 -0000

ros-melodic-canopen-chain-node (0.7.4-1bionic) bionic; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 24 Apr 2017 22:00:00 -0000

ros-melodic-canopen-chain-node (0.7.3-1bionic) bionic; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 24 Apr 2017 22:00:00 -0000

ros-melodic-canopen-chain-node (0.7.2-1bionic) bionic; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 27 Mar 2017 22:00:00 -0000

ros-melodic-canopen-chain-node (0.7.1-1bionic) bionic; urgency=high

  * refactored EMCY handling into separate layer
  * do not reset thread for recover
  * properly stop run thread if init failed
  * deprecation warning for SHM-based master implementations
  * implemented canopen_sync_node
  * wait only if sync is disabled
  * added object access services
  * implement level-based object logging
  * added node name lookup
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 19 Mar 2017 23:00:00 -0000

ros-melodic-canopen-chain-node (0.7.0-1bionic) bionic; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 12 Dec 2016 23:00:00 -0000

ros-melodic-canopen-chain-node (0.6.5-1bionic) bionic; urgency=high

  * protect MotorChain setup with RosChain lock
  * added include to <boost/scoped_ptr.hpp>; solving #177 <https://github.com/ipa-mdl/ros_canopen/issues/177>
  * default to canopen::SimpleMaster::Allocator (#71 <https://github.com/ipa-mdl/ros_canopen/issues/71>)
  * exit code for generic error should be 1, not -1
  * styled and sorted CMakeLists.txt
    * removed boilerplate comments
    * indention
    * reviewed exported dependencies
  * styled and sorted package.xml
  * update package URLs
  * moved roslib include into source file
  * renamed chain_ros.h to ros_chain.h, fixes #126 <https://github.com/ipa-mdl/ros_canopen/issues/126>
  * Use of catkin_EXPORTED_TARGETS
    Install target for canopen_ros_chain
  * Splitted charn_ros.h into chain_ros.h and ros_chain.cpp
  * Revert "stop heartbeat after stack was shutdown"
    This reverts commit de985b5e9664edbbcc4f743fff3e2a2391e1bf8f.
  * improve failure handling in init service callback
  * improved excetion handling in init and recover callback
  * Merge pull request #109 <https://github.com/ipa-mdl/ros_canopen/issues/109> from ipa-mdl/shutdown-crashes
    Fix for pluginlib-related crashes on shutdown
  * catch std::exception instead of canopen::Exception (#110 <https://github.com/ipa-mdl/ros_canopen/issues/110>)
  * call to detroy is not needed anymore
  * added GuardedClassLoader implementation
  * minor shutdown improvements
  * Contributors: Mathias Lüdtke, Michael Stoll, xaedes

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 09 Dec 2016 23:00:00 -0000

ros-melodic-canopen-chain-node (0.6.4-1bionic) bionic; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 02 Jul 2015 22:00:00 -0000

ros-melodic-canopen-chain-node (0.6.3-1bionic) bionic; urgency=high



=== debian/control ===
Source: ros-melodic-canopen-chain-node
Section: misc
Priority: optional
Maintainer: Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-canopen-master, ros-melodic-catkin, ros-melodic-diagnostic-updater, ros-melodic-message-generation, ros-melodic-pluginlib, ros-melodic-rosconsole-bridge, ros-melodic-roscpp, ros-melodic-roslib, ros-melodic-socketcan-interface, ros-melodic-std-msgs, ros-melodic-std-srvs
Homepage: http://wiki.ros.org/canopen_chain_node
Standards-Version: 3.9.2

Package: ros-melodic-canopen-chain-node
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-canopen-master, ros-melodic-diagnostic-updater, ros-melodic-message-runtime, ros-melodic-pluginlib, ros-melodic-rosconsole-bridge, ros-melodic-roscpp, ros-melodic-roslib, ros-melodic-socketcan-interface, ros-melodic-std-msgs, ros-melodic-std-srvs
Description: Base implementation for CANopen chains node with support for management services and diagnostics

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-canopen-chain-node//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
